<?php

//--------------------------------------------------

namespace Bbg\ProductAssets\Cache;

//--------------------------------------------------

//--------------------------------------------------

class FileCache extends AbstractCache {

//--------------------------------------------------
// Public:Propertys


//--------------------------------------------------
// Private:Propertys


//--------------------------------------------------
// Protected:Propertys

	
//--------------------------------------------------
// Constants


//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	public function __construct(int $ttl=0, array $config=array()){
		$config = array_merge(array(
			"cacheDir" => __DIR__, 
			), $config);
		
		parent::__construct($ttl, $config);
		}

//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	public function exists(string $path, ?string $environment=null):bool {
		$key = $this->key($path, $environment);
		
		if(!file_exists(($file = $this->getFile($key)))){
			return false;
			}

		if(filemtime($file) < time()){
			return false;
			}
		
		if(!is_readable($file)){
			return false;
			}
		
		return true;
		}

//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	public function read(string $path, ?string $environment=null):\stdClass {
		$key = $this->key($path, $environment);
		
		if(file_exists(($file = $this->getFile($key)))){
			return json_decode(file_get_contents($file));
			}
		
		return new \stdClass();
		}

//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	public function write(string $path, \stdClass $content, ?string $environment=null):bool {
		$key = $this->key($path, $environment);
		
		if(!file_exists(($file = $this->getFile($key)))){
			if(file_put_contents($file, json_encode($content, JSON_PRETTY_PRINT))){
				return touch($file, (time() + $this->getTTL()));
				}
			}
		
		return false;
		}

//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	private function getFile(string $key):string {
		return rtrim($this->config["cacheDir"], DIRECTORY_SEPARATOR).DIRECTORY_SEPARATOR.$key.".cache";
		}

//--------------------------------------------------

	}

//--------------------------------------------------

?>