<?php

//--------------------------------------------------

namespace Bbg\ProductAssets\Entity;

//--------------------------------------------------

use Bbg\ProductAssets\CDN\AbstractCDN;

//--------------------------------------------------

abstract class AbstractEntity {

//--------------------------------------------------
// Public:Propertys


//--------------------------------------------------
// Private:Propertys
	private $cdn;
	private $url;
	private $path;

//--------------------------------------------------
// Protected:Propertys

	
//--------------------------------------------------
// Constants


//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	public function __construct(?\stdClass $data=null, ?string $path=null, ?AbstractCDN $cdn=null){
		$this
			->setPath($path)
			;
			
		if(!is_null($cdn)){
			$this
				->setCDN($cdn)
				;
			}
		}

//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	public function setUrl(string $value):AbstractEntity {
		$this->url = $value;
		
		return $this;
		}

//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	public function getUrl(?array $args=null):string {
		return $this->getFullPath($this->url, $args);
		}

//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	public function setCDN(AbstractCDN $cdn): AbstractEntity {
		$this->cdn = $cdn;
		
		return $this;
		}

//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	public function getCDN(): ?AbstractCDN {
		return $this->cdn;
		}

//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	public function setPath(string $path): AbstractEntity {
		$this->path = $path;
		
		return $this;
		}

//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	public function getPath():string {
		return $this->path;
		}

//--------------------------------------------------
/**
* No Information Found
* @since 1.0
*/
	protected function getFullPath(?string $url, ?array $args=null):string {
		if(is_null($url)){
			return "";
			}
		
		$fullPath = $this->getPath().$url;
		
		if((is_object($this->cdn)) && ($this->cdn instanceof AbstractCDN)){
			return $this->cdn->getPath($fullPath, $args);
			}
		
		return $fullPath;
		}

//--------------------------------------------------

	}

//--------------------------------------------------

?>