<?php declare(strict_types=1);

//--------------------------------------------------

require_once __DIR__ . '/../vendor/autoload.php';

//--------------------------------------------------

use Bbg\ProductAssets\Entity\BeforeAfterEntity;
use PHPUnit\Framework\TestCase;

//--------------------------------------------------

final class BeforeAfterEntityTest extends TestCase
{
    public function testConstruct(): BeforeAfterEntity
    {
        $entity = new BeforeAfterEntity();
        $this->assertIsObject($entity);

        return $entity;
    }

    /**
     * @depends testConstruct
     */
    public function testSet(BeforeAfterEntity $entity): BeforeAfterEntity
    {
        $entity
        	->setBeforeUrl("/beforeAfter/globals/0/before.jpg")
        	->setBeforeCaption("Before Image")
        	->setBeforeHeight(300)
        	->setBeforeWidth(400)
        	
        	->setAfterUrl("/beforeAfter/globals/0/after.jpg")
        	->setAfterCaption("After Image")
        	->setAfterHeight(300)
        	->setAfterWidth(400)
        	;
		
		$this->assertIsObject($entity);
		
        return $entity;
    }

    /**
     * @depends testSet
     */
    public function testGet(BeforeAfterEntity $entity): void
    {
        $this->assertIsString($entity->getBeforeUrl());
        $this->assertIsString($entity->getBeforeCaption());
        $this->assertIsInt($entity->getBeforeHeight());
        $this->assertIsInt($entity->getBeforeWidth());
        
        $this->assertIsString($entity->getAfterUrl());
        $this->assertIsString($entity->getAfterCaption());
        $this->assertIsInt($entity->getAfterHeight());
        $this->assertIsInt($entity->getAfterWidth());
    }
}

//--------------------------------------------------

?>